import {
  __name
} from "./chunk-YPCYSKQX.esm.js";

// src/checkbox-icon.tsx
import { isVNode as _isVNode, mergeProps as _mergeProps, createVNode as _createVNode } from "vue";
import { useMotions } from "@vueuse/motion";
import { defineComponent, computed, onBeforeUnmount } from "vue";
import { chakra } from "@chakra-ui/vue-system";
import { CMotion } from "@chakra-ui/c-motion";
import { genId } from "@chakra-ui/vue-utils";
function _isSlot(s) {
  return typeof s === "function" || Object.prototype.toString.call(s) === "[object Object]" && !_isVNode(s);
}
__name(_isSlot, "_isSlot");
var CheckIcon = defineComponent({
  name: "CheckboxCheckIcon",
  setup(_, {
    attrs,
    slots
  }) {
    const transitionId = `check-icon-${genId()}`;
    const leave = /* @__PURE__ */ __name((done) => {
      const motions = useMotions();
      const instance = motions[transitionId];
      instance == null ? void 0 : instance.leave(() => {
        done();
      });
    }, "leave");
    onBeforeUnmount(() => {
      leave(() => null);
    });
    return () => _createVNode(chakra.svg, _mergeProps({
      "width": "1.2em",
      "viewBox": "0 0 12 10",
      "style": {
        fill: "none",
        strokeWidth: 2,
        stroke: "currentColor",
        strokeDasharray: 16
      }
    }, attrs), {
      default: () => _createVNode("polyline", {
        "points": "1.5 6 4.5 9 10.5 1"
      }, null)
    });
  }
});
var IndeterminateIcon = defineComponent({
  name: "CheckboxIndeterminateIcon",
  setup(_, {
    attrs,
    slots
  }) {
    const transitionId = `indeterminate-icon-${genId()}`;
    const leave = /* @__PURE__ */ __name((done) => {
      const motions = useMotions();
      const instance = motions[transitionId];
      instance == null ? void 0 : instance.leave(() => {
        done();
      });
    }, "leave");
    onBeforeUnmount(() => {
      leave(() => null);
    });
    return () => _createVNode(chakra.svg, _mergeProps({
      "width": "1.2em",
      "viewBox": "0 0 24 24",
      "style": {
        stroke: "currentColor",
        strokeWidth: 4
      }
    }, attrs), {
      default: () => _createVNode("line", {
        "x1": "21",
        "x2": "3",
        "y1": "12",
        "y2": "12"
      }, null)
    });
  }
});
var CCheckboxTransition = defineComponent({
  name: "CCheckboxTransition",
  props: {
    open: Boolean
  },
  setup(props, {
    attrs,
    slots
  }) {
    return () => _createVNode(CMotion, {
      "type": "scale",
      "style": {
        display: "flex",
        alignItems: "center",
        justifyContent: "center",
        height: "100%"
      }
    }, {
      default: () => [props.open ? () => _createVNode(chakra.div, null, _isSlot(slots) ? slots : {
        default: () => [slots]
      }) : null]
    });
  }
});
var CheckboxIcon = defineComponent((props, {
  slots,
  attrs
}) => {
  const IconEl = computed(() => props.isIndeterminate ? IndeterminateIcon : CheckIcon);
  return () => _createVNode(IconEl.value, attrs, null);
});
CheckboxIcon.name = "CheckboxIcon";
CheckboxIcon.props = {
  isIndeterminate: Boolean,
  isChecked: Boolean
};

export {
  CheckIcon,
  IndeterminateIcon,
  CCheckboxTransition,
  CheckboxIcon
};
